<?php
// Die if we are called via web, we only want to be run from command line
if (php_sapi_name() !='cli') exit;

$dir = dirname(__FILE__);
$two_folders_up = dirname(dirname($dir));
chdir($two_folders_up);

require_once("config.php");
require_once("functions.php");
require_once("dblib.php");
require_once("asmanager.php");
require_once("system.php");

if(file_exists("/etc/freepbx.conf")) {
   $conf = parse_conf("/etc/freepbx.conf");
} else if(file_exists("/etc/amportal.conf")) {
   $conf = parse_conf("/etc/amportal.conf");
}

$db = new mysqli($conf['DBHOST'], $conf['DBUSER'], $conf['DBPASS'], $conf['DBNAME']);
if ($db->connect_errno) {
    echo "Could not connect to MySQL: (" . $db->connect_errno . ") " . $db->connect_error;
    die();
}

$seteo=array();
$dir = dirname(__FILE__);
$inifile = $dir."/callflowfpbx.ini";
$seteo = parse_ini_file($inifile,true);
$xmlfile =  $dir."/plugin.xml";


$callflow_count = intval($seteo['callflow_count']);
if($callflow_count<=0) $callflow_count=20;

$howmany = $callflow_count - 1;

$extraquery='';
if(isset($seteo['check_timecondition'])) {
    if($seteo['check_timecondition']==1) {
        $extraquery = " OR modulename='timeconditions' ";
    }
}

$query = "SELECT description,defaultcode FROM featurecodes WHERE (modulename='daynight' $extraquery)";
if(!$result = $db->query($query)){
    die('There was an error running the query [' . $db->error . ']');
}

$clean_seteo = array();
foreach($seteo as $key=>$val) {
    if(!strstr($key,"name_")) {
        $clean_seteo[$key]=$val;
    } else {
        if($val!='') {
            $clean_seteo[$key]=$val;
        }
    }
}
$seteo = $clean_seteo;

for($a=0;$a<$callflow_count;$a++) {
    if(!isset($seteo['name_'.$a])) {
        $seteo['name_'.$a]='';
    }
}

$noallprefix='';
$allprefix='';
while($row = $result->fetch_assoc()){
    $partes = preg_split("/: /",$row['description']);
    $index = $partes[0];
    $nombre = $partes[1];
    $noallprefix = substr($row['defaultcode'],0,-1);
    if($seteo['name_'.$index]=='') {
        $seteo['name_'.$index]=$nombre;
    }
    if($index=='All') {
        $allprefix = $row['defaultcode'];
    }
}
if($allprefix<>'') {
    $seteo['featurecode_prefix'] = $allprefix;
} else {
    $seteo['featurecode_prefix'] = $noallprefix;
}


$fp = fopen($inifile,"w");
foreach($seteo as $key=>$val) {
    $linea = $key." = \"".$val."\"\n";
    fputs($fp,$linea);
}
fclose($fp);

$allpars = plugin_read_xml_params('callflowfpbx');
$newpars = array();
$newpars['params']=array();
$existing_names=0;
foreach($allpars['param'] as $key=>$val) {

 if(strstr($val['name'],"name_")!==false) {
    $existing_names++;
    $index = substr($val['name'],5);
    if($index<=$howmany) {
        $newpars['params'][] = $val;
    } else {
        echo "descarto $index\n";
    }
 } else {
    $newpars['params'][] = $val;
 }
}

$faltan = $howmany - $existing_names;

if($faltan>0) {
    for($i=$existing_names;$i<=$howmany;$i++) {
        $newpars['params'][]=array('name'=>'name_'.$i,'type'=>'text','multi'=>'no','default'=>'');
    }
}

// sort by name key
usort($newpars['params'], function ($a, $b) {
    return strnatcmp($a['name'], $b['name']);
});

$allxml = plugin_read_xml('callflowfpbx');
$allxml['params'] = $newpars['params'];

$xml = convert_array_to_formatted_xml_string($allxml,'plugin');

file_put_contents($xmlfile,$xml);

function array_to_xml($array, &$xml) {
    foreach ($array as $key => $value) {
        // If the key is numeric, use a generic 'item' tag
        if (is_numeric($key)) {
            $key = 'param';
        }

        // If the value is an array, recurse
        if (is_array($value)) {
            $subnode = $xml->addChild($key);
            array_to_xml($value, $subnode);
        } else {
            // Add the value directly
            $xml->addChild($key, htmlspecialchars($value));
        }
    }
}

function convert_array_to_formatted_xml_string($array, $rootElement = 'root') {
    // Create a SimpleXMLElement object
    $xml = new SimpleXMLElement("<$rootElement/>");

    // Recursively build XML from the array
    array_to_xml($array, $xml);

    // Convert to DOMDocument for formatting
    $dom = new DOMDocument('1.0', 'UTF-8');
    $dom->preserveWhiteSpace = false;
    $dom->formatOutput = true;

    // Load the SimpleXMLElement into DOMDocument
    $dom->loadXML($xml->asXML());

    // Return the formatted XML string
    return $dom->saveXML($dom->documentElement);
}

function plugin_read_xml($rawname) {
    global $PLUGIN_DIR;
    if(is_readable($PLUGIN_DIR.$rawname.'/plugin.xml')) {
        $data = file_get_contents($PLUGIN_DIR.$rawname.'/plugin.xml');
        $xml = simplexml_load_string($data);
        $xmlarray = simple_xml_to_array($xml);
    }
    $ret = $xmlarray;

    return $ret;
}
